
// QTreeDiffRunner: a gizmo (not a widget) responsible for calling
// an external diff program, and then cleaning up temp files after
// that program exits.  

#ifndef QTREEDIFFRUNNER_H

#include <clientapi.h>
#include <qmessagebox.h>
#include <qprocess.h>

#endif//QTREEDIFFRUNNER_H

class QTreeDiffRunner : public QObject  
{
	Q_OBJECT
public:
	QTreeDiffRunner
		( QWidget* parent, const char* diffprog, FileSys* t1, FileSys* t2, QString n1, QString n2 );
	virtual ~QTreeDiffRunner();
private slots:
	void Cleanup();
	void Close();
private:
	QProcess* pro;
	FileSys *temp1, *temp2;
};
